//M.Sewell@cs.ucl.ac.uk

#include <windows.h>
#include <stdio.h>
#include "resource.h"
#include "svm_common.h"

char DefaultTrainFile[200] = "train.txt";
char DefaultModelFile[200] = "model.txt";
char DefaultTestFile[200] = "test.txt";
char DefaultPredictionsFile[200] = "predictions.txt";
char DefaultOptimizeFile[200] = "optimize.csv";



char TrainFilename[200] = "train.txt";
char ModelFilename[200] = "model.txt";
char TestFilename[200] = "test.txt";
char PredictionsFilename[200] = "predictions.txt";
char OptimizeFilename[200] = "optimize.csv";


FILE *train_stream;
FILE *model_stream;
FILE *test_stream;
FILE *predictions_stream;
FILE *optimize_stream;

FILE *output_stream;






HWND hWndButtonTrain;
HWND hWndButtonModel;
HWND hWndButtonTest;
HWND hWndButtonPredictions;
HWND hWndButtonOptimize;

HWND hWndButtonLearn;
HWND hWndButtonClassify;
HWND hWndButtonOptimize;

HWND hwndEditClassification ;
HWND hwndEditRegression ;
HWND hwndEditPR ;


HWND hwndEditC ;
HWND hwndEditE ;



HWND hwndEditL ;

HWND hwndEditP ;
HWND hwndEditP1 ;
HWND hwndEditP2 ;
HWND hwndEditP3 ;

HWND hwndEditR ;
HWND hwndEditR1 ;

HWND hwndEditS ;
HWND hwndEditS1 ;
HWND hwndEditS2 ;


HWND hwndEditCa;
HWND hwndEditCb;
HWND hwndEditEa;
HWND hwndEditEb;
HWND hwndEditLo;
HWND hwndEditPo;
HWND hwndEditP1a;
HWND hwndEditP1b;
HWND hwndEditP2a;
HWND hwndEditP2b;
HWND hwndEditP3a;
HWND hwndEditP3b;
HWND hwndEditRo;
HWND hwndEditR1a;
HWND hwndEditR1b;
HWND hwndEditSo;
HWND hwndEditS1a;
HWND hwndEditS1b;
HWND hwndEditS2a;
HWND hwndEditS2b;
HWND hwndEditRuns;

HWND hwndEditTrainFilename;
HWND hwndEditTestFilename;
HWND hwndEditModelFilename;
HWND hwndEditPredictionsFilename;
HWND hwndEditOptimizeFilename;
HWND hwndEditCounter;


int  GetTrainFilename(char *, char *);
int  GetModelFilename(char *);

int  GetTestFilename(char *, char *);
int  GetPredictionsFilename(char *);

int  GetOptimizeFilename(char *);

char perc[5];

//Martin's hack
int random_range(int lowest_number, int highest_number)
{
    int range = highest_number - lowest_number + 1;
    return lowest_number + (int)(range * rand()/(RAND_MAX + 1.0));
}






int GetTrainFilename(char *MatchType, char *MatchFile)
{
   OPENFILENAME fn;
   register int i;
   char Filter[128];
   // construct file name filter string
   lstrcpy(Filter,MatchType);
   i = lstrlen(Filter) + 1;
   lstrcpy(&Filter[i],MatchFile);
   i += lstrlen(&Filter[i]) + 1;
   Filter[i] = '\0';
   // fill in structure fields for Open File dialog box
   fn.lStructSize       = sizeof(OPENFILENAME);
   fn.hwndOwner         = GetActiveWindow();
   fn.lpstrFilter       = Filter;
   fn.lpstrCustomFilter = NULL;
   fn.nFilterIndex      = 0;
   fn.lpstrFile         = NULL;
   fn.lpstrFile         = DefaultTrainFile;
   fn.nMaxFile          = sizeof(DefaultTrainFile);
   fn.lpstrFileTitle    = NULL;
   fn.lpstrInitialDir   = NULL;
   fn.lpstrTitle        = NULL;
   fn.Flags             = OFN_READONLY;
   fn.lpstrDefExt       = &MatchFile[2];
   *DefaultTrainFile = '\0';
   // activate the Open File dialog box
   if (GetOpenFileName(&fn))
   {
      lstrcpy(TrainFilename,DefaultTrainFile);
      return 1;
   }
   else
      return -1;
}


int GetTestFilename(char *MatchType, char *MatchFile)
{
   OPENFILENAME fn;
   register int i;
   char Filter[128];
   // construct file name filter string
   lstrcpy(Filter,MatchType);
   i = lstrlen(Filter) + 1;
   lstrcpy(&Filter[i],MatchFile);
   i += lstrlen(&Filter[i]) + 1;
   Filter[i] = '\0';
   // fill in structure fields for Open File dialog box
   fn.lStructSize       = sizeof(OPENFILENAME);
   fn.hwndOwner         = GetActiveWindow();
   fn.lpstrFilter       = Filter;
   fn.lpstrCustomFilter = NULL;
   fn.nFilterIndex      = 0;
   fn.lpstrFile         = NULL;
   fn.lpstrFile         = DefaultTestFile;
   fn.nMaxFile          = sizeof(DefaultTestFile);
   fn.lpstrFileTitle    = NULL;
   fn.lpstrInitialDir   = NULL;
   fn.lpstrTitle        = NULL;
   fn.Flags             = OFN_READONLY;
   fn.lpstrDefExt       = &MatchFile[2];
   *DefaultTestFile = '\0';
   // activate the Open File dialog box
   if (GetSaveFileName(&fn))
   {
      lstrcpy(TestFilename,DefaultTestFile);
      return 1;
   }
   else
      return -1;
}




int GetModelFilename(char *DefaultExt)
{
   OPENFILENAME fn;
   // fill in structure fields for Save File dialog box
   fn.lStructSize       = sizeof(OPENFILENAME);
   fn.hwndOwner         = GetActiveWindow();
   fn.lpstrCustomFilter = NULL;
   fn.nFilterIndex      = 0;
   fn.lpstrFile         = DefaultModelFile;
   fn.nMaxFile          = sizeof(DefaultModelFile);
   fn.lpstrFileTitle    = NULL;
   fn.lpstrInitialDir   = NULL;
   fn.lpstrTitle        = NULL;
   fn.Flags             = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT |
                          OFN_PATHMUSTEXIST;
   fn.lpstrDefExt       = DefaultExt;
   // construct file name filter string and default file name string
   lstrcpy(DefaultModelFile,ModelFilename);
   if (lstrcmp(DefaultExt,"txt") == 0)
   {
      fn.lpstrFilter = "TXT files (*.txt)\0*.txt\0\0";
      lstrcpy(strrchr(DefaultModelFile,'.'),".txt");
   }
   else
   {
      fn.lpstrFilter = NULL;
   }
   // activate the Open File dialog box
   if (GetSaveFileName(&fn))
   {
      lstrcpy(ModelFilename,DefaultModelFile);
      return 0;
   }
   else
      return -1;
}

int GetPredictionsFilename(char *DefaultExt)
{
   OPENFILENAME fn;
   // fill in structure fields for Save File dialog box
   fn.lStructSize       = sizeof(OPENFILENAME);
   fn.hwndOwner         = GetActiveWindow();
   fn.lpstrCustomFilter = NULL;
   fn.nFilterIndex      = 0;
   fn.lpstrFile         = DefaultPredictionsFile;
   fn.nMaxFile          = sizeof(DefaultPredictionsFile);
   fn.lpstrFileTitle    = NULL;
   fn.lpstrInitialDir   = NULL;
   fn.lpstrTitle        = NULL;
   fn.Flags             = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT |
                          OFN_PATHMUSTEXIST;
   fn.lpstrDefExt       = DefaultExt;
   // construct file name filter string and default file name string
   lstrcpy(DefaultPredictionsFile,PredictionsFilename);
   if (lstrcmp(DefaultExt,"txt") == 0)
   {
      fn.lpstrFilter = "TXT files (*.txt)\0*.txt\0\0";
      lstrcpy(strrchr(DefaultPredictionsFile,'.'),".txt");
   }
   else
   {
      fn.lpstrFilter = NULL;
   }
   // activate the Open File dialog box
   if (GetSaveFileName(&fn))
   {
      lstrcpy(PredictionsFilename,DefaultPredictionsFile);
      return 0;
   }
   else
      return -1;
}


int GetOptimizeFilename(char *DefaultExt)
{
   OPENFILENAME fn;
   // fill in structure fields for Save File dialog box
   fn.lStructSize       = sizeof(OPENFILENAME);
   fn.hwndOwner         = GetActiveWindow();
   fn.lpstrCustomFilter = NULL;
   fn.nFilterIndex      = 0;
   fn.lpstrFile         = DefaultOptimizeFile;
   fn.nMaxFile          = sizeof(DefaultOptimizeFile);
   fn.lpstrFileTitle    = NULL;
   fn.lpstrInitialDir   = NULL;
   fn.lpstrTitle        = NULL;
   fn.Flags             = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT |
                          OFN_PATHMUSTEXIST;
   fn.lpstrDefExt       = DefaultExt;
   // construct file name filter string and default file name string
   lstrcpy(DefaultOptimizeFile,OptimizeFilename);
   if (lstrcmp(DefaultExt,"txt") == 0)
   {
      fn.lpstrFilter = "TXT files (*.txt)\0*.txt\0\0";
      lstrcpy(strrchr(DefaultOptimizeFile,'.'),".txt");
   }
   else
   {
      fn.lpstrFilter = NULL;
   }
   // activate the Open File dialog box
   if (GetSaveFileName(&fn))
   {
      lstrcpy(OptimizeFilename,DefaultOptimizeFile);
      return 0;
   }
   else
      return -1;
}



optimize() {
    time_t begin, end;
    double time_elapsed;
    int iLength;
    PTSTR pstrDoc;
    float C_min = 0;
    float C_max = 0;
    float epsilon_min = 0;
    float epsilon_max = 0;

    if ((output_stream = fopen("outputo.txt", "w")) == NULL) {
        MessageBox(NULL, "outputo.txt", "Failed to open file", MB_OK | MB_ICONINFORMATION);
        exit(-1);
    }

    if (
 (int) SendMessage (hwndEditLo, BM_GETCHECK, 0, 0) +
 (int) SendMessage (hwndEditPo, BM_GETCHECK, 0, 0) +
 (int) SendMessage (hwndEditRo, BM_GETCHECK, 0, 0) +
 (int) SendMessage (hwndEditSo, BM_GETCHECK, 0, 0)
 == 0) {
          MessageBox(NULL, "Select at least one kernel", "Error", MB_OK | MB_ICONINFORMATION);
    }
    else {


    iLength = GetWindowTextLength (hwndEditCa);
    if (NULL == (pstrDoc = (PTSTR) malloc ((iLength + 1) * sizeof (TCHAR))))
        exit(0);
    GetWindowText (hwndEditCa, pstrDoc, iLength + 1) ;
    if(iLength > 0) {
        C_min = atof(pstrDoc);
    }
    free(pstrDoc);
    iLength = GetWindowTextLength (hwndEditCb);
    if (NULL == (pstrDoc = (PTSTR) malloc ((iLength + 1) * sizeof (TCHAR))))
        exit(0);
    GetWindowText (hwndEditCb, pstrDoc, iLength + 1) ;
    if(iLength > 0) {
        C_max = atof(pstrDoc);
    }
    free(pstrDoc);







    if (C_min < 0 || C_max < 0)
        MessageBox(NULL, "C must be non-negative", "Error", MB_OK | MB_ICONINFORMATION);
    else
    {




    iLength = GetWindowTextLength (hwndEditEa);
    if (NULL == (pstrDoc = (PTSTR) malloc ((iLength + 1) * sizeof (TCHAR))))
        exit(0);
    GetWindowText (hwndEditEa, pstrDoc, iLength + 1) ;
    if(iLength > 0) {
        epsilon_min = atof(pstrDoc);
    }
    free(pstrDoc);
    iLength = GetWindowTextLength (hwndEditEb);
    if (NULL == (pstrDoc = (PTSTR) malloc ((iLength + 1) * sizeof (TCHAR))))
        exit(0);
    GetWindowText (hwndEditEb, pstrDoc, iLength + 1) ;
    if(iLength > 0) {
        epsilon_max = atof(pstrDoc);
    }
    free(pstrDoc);


       if (epsilon_min < 0 || epsilon_max < 0)
        MessageBox(NULL, "Epsilon must be non-negative", "Error", MB_OK | MB_ICONINFORMATION);
    else
    {





        iLength = GetWindowTextLength (hwndEditRuns);
    if (NULL == (pstrDoc = (PTSTR) malloc ((iLength + 1) * sizeof (TCHAR))))
        exit(0);
    GetWindowText (hwndEditRuns, pstrDoc, iLength + 1) ;
    if(iLength > 0) {
        windows_runs = atoi(pstrDoc);
    }
    else windows_runs = 0;
    free(pstrDoc);



float cwr;
int ti;
int ui;
char tc;
char uc;


            perc[0] = ' ';
            perc[1] = ' ';
            perc[2] = '0';
            perc[3] = '%';
            perc[4] = '\0';

SendMessage(hwndEditCounter, WM_SETTEXT, 0, (LPARAM)perc);
int count;
    for (count=1; count<=windows_runs; count++) {
        begin = clock();
        learn_optimize();

        cwr = (float)((float)count/(float)windows_runs);
        cwr = (float)100*cwr;

    ti = (int) (cwr/10);
    ui = (int) cwr % 10;
    tc = (char) (ti + '0');
    uc = (char) (ui + '0');
    perc[0] = ' ';
    perc[1] = tc;
    if (perc[1] == '0')
        perc[1] = ' ';
    perc[2] = uc;
    perc[3] = '%';
    perc[4] = '\0';

    SendMessage(hwndEditCounter, WM_SETTEXT, 0, (LPARAM)perc);



        classify_optimize();
        end = clock();

        if (count == 1) {
            if ((optimize_stream = fopen(OptimizeFilename, "w")) == NULL) {
                MessageBox(NULL, OptimizeFilename, "Failed to open file", MB_OK | MB_ICONINFORMATION);
                exit(-1);
            }
            if (windows_type == REGRESSION) {
                //fprintf(optimize_stream, "Profit,MSE,time/s,C,epsilon,kernel,param1,param2,param3\n");
                fprintf(optimize_stream, "MSE,time/s,C,epsilon,kernel,param1,param2,param3\n");
                }
            else {
                //fprintf(optimize_stream, "Profit,Accuracy/%%,time/s,C,kernel,param1,param2,param3\n");
                fprintf(optimize_stream, "Accuracy/%%,time/s,C,kernel,param1,param2,param3\n");
                }
        }
        else {
            if ((optimize_stream = fopen(OptimizeFilename, "a")) == NULL) {
                MessageBox(NULL, OptimizeFilename, "Failed to open file", MB_OK | MB_ICONINFORMATION);
                exit(-1);
            }
        }
        time_elapsed = (double)(end-begin)/CLOCKS_PER_SEC;
        //fprintf(output_stream, "Time elapsed: %7.2lfs\n", time_elapsed);

    //fprintf(optimize_stream, "%d %.2f%% %.2f%% %.2f%% ", count, windows_accuracy, windows_precision, windows_recall);

    if (windows_type == REGRESSION) {
        //fprintf(optimize_stream, "%.6f, %.6f, %.3f, %.6f, %.6f,", windows_profit, windows_MSE, time_elapsed, windows_svm_c_o, windows_eps_o);
        fprintf(optimize_stream, "%.6f, %.3f, %.6f, %.6f,", windows_MSE, time_elapsed, windows_svm_c_o, windows_eps_o);
        }
    else {
        //fprintf(optimize_stream, "%.6f, %.3f%%, %.3f, %.6f,", windows_profit, windows_accuracy, time_elapsed, windows_svm_c_o);
        fprintf(optimize_stream, "%.3f%%, %.3f, %.6f,", windows_accuracy, time_elapsed, windows_svm_c_o);
        }



    switch (windows_kernel_type_o) {
        case 0:
            fprintf(optimize_stream, "linear\n");
            break;
        case 1:
            fprintf(optimize_stream, "poly, %d, %.6f, %.6f\n", windows_P1_o, windows_P2_o, windows_P3_o);
            break;
        case 2:
            fprintf(optimize_stream, "rbf, %.6f\n", windows_R1_o);
            break;
        case 3:
            fprintf(optimize_stream, "sigmoid, %.6f, %.6f\n", windows_S1_o, windows_S2_o);
            break;
    }
    fclose(optimize_stream);
}


            perc[0] = '1';
            perc[1] = '0';
            perc[2] = '0';
            perc[3] = '%';
            perc[4] = '\0';
        SendMessage(hwndEditCounter, WM_SETTEXT, 0, (LPARAM)perc);


fclose(output_stream);

}
}
}
}





/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

/*  Make the class name into a global variable  */
char szClassName[ ] = "SVMdark";

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{

    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = szClassName;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    wincl.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);





    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "SVMdark",            /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           800,                 /* The programs width 544 */
           600,                 /* and height in pixels 375 */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

srand(time(0));

CheckRadioButton (hwnd, IDB_BUTTON_C, IDB_BUTTON_PR, IDB_BUTTON_C);
CheckRadioButton (hwnd, IDB_BUTTON_L, IDB_BUTTON_RBF, IDB_BUTTON_L);




    /* Make the window visible on the screen */
    ShowWindow (hwnd, nFunsterStil);


    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        if(!IsDialogMessage(hwnd, &messages) ){
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
        }
    }
    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    HMENU hMenu;
    hMenu = GetMenu (hwnd) ;
    HDC hdc ;
    PAINTSTRUCT ps ;
    TEXTMETRIC tm ;
    HINSTANCE hInstance = (HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE);
    int i;






    switch (message)                  /* handle the messages */
    {





    case WM_CREATE:

            InvalidateRect(hwnd, NULL, TRUE);


            //classification
            hwndEditClassification = CreateWindow (TEXT ("button"), "Classification",
                         WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON | WS_GROUP | WS_TABSTOP,
                         20, 10, 110, 20,
                         hwnd, (HMENU) IDB_BUTTON_C, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;


            //regression
            hwndEditRegression = CreateWindow (TEXT ("button"), "Regression",
                         WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, //NO TABSTOP
                         20, 30, 110, 20,
                         hwnd, (HMENU) IDB_BUTTON_R, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;


            //preference ranking
            hwndEditPR = CreateWindow (TEXT ("button"), "Preference Ranking",
                         WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, //NO TABSTOP
                         20, 50, 150, 20,
                         hwnd, (HMENU) IDB_BUTTON_PR, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;


            //C
            hwndEditC = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         80, 120, 70, 20,
                         hwnd, (HMENU) ID_EDIT_C, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

            //epsilon
            hwndEditE = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         80, 140, 70, 20,
                         hwnd, (HMENU) ID_EDIT_E, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

//RADIO
            hwndEditL = CreateWindow (TEXT ("button"), "linear",
                         WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON | WS_GROUP | WS_TABSTOP,
                         80, 160, 70, 20,
                         hwnd, (HMENU) IDB_BUTTON_L, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditP = CreateWindow (TEXT ("button"), "polynomial",
                         WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, //NO TABSTOP
                         80, 180, 100, 20,
                         hwnd, (HMENU) IDB_BUTTON_P, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditR = CreateWindow (TEXT ("button"), "radial basis function",
                         WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, //NO TABSTOP
                         80, 200, 150, 20,
                         hwnd, (HMENU) IDB_BUTTON_RBF, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditS = CreateWindow (TEXT ("button"), "sigmoid",
                         WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, //NO TABSTOP
                         80, 220, 70, 20,
                         hwnd, (HMENU) IDB_BUTTON_S, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;



            //linear

            //polynomial
            hwndEditP1 = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | ES_NUMBER | WS_TABSTOP,
                         290, 180, 70, 20,
                         hwnd, (HMENU) ID_EDIT_P1, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditP2 = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         390, 180, 70, 20,
                         hwnd, (HMENU) ID_EDIT_P2, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditP3 = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         490, 180, 70, 20,
                         hwnd, (HMENU) ID_EDIT_P3, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;



            //radial basis function
            hwndEditR1 = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         290, 200, 70, 20,
                         hwnd, (HMENU) ID_EDIT_RBF1, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;


            //sigmoid

            hwndEditS1 = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         290, 220, 70, 20,
                         hwnd, (HMENU) ID_EDIT_S1, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditS2 = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         390, 220, 70, 20,
                         hwnd, (HMENU) ID_EDIT_S2, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;






//Optimize
           //C
            hwndEditCa = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         80, 340, 60, 20,
                         hwnd, (HMENU) ID_EDIT_Ca, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

            hwndEditCb = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         140, 340, 60, 20,
                         hwnd, (HMENU) ID_EDIT_Cb, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;


            //epsilon
            hwndEditEa = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         80, 360, 60, 20,
                         hwnd, (HMENU) ID_EDIT_Ea, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

            hwndEditEb = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         140, 360, 60, 20,
                         hwnd, (HMENU) ID_EDIT_Eb, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

//RADIO
            hwndEditLo = CreateWindow (TEXT ("button"), "linear",
                         WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX | WS_TABSTOP,
                         80, 380, 60, 20,
                         hwnd, (HMENU) IDB_BUTTON_Lo, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

            hwndEditPo = CreateWindow (TEXT ("button"), "polynomial",
                         WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX,
                         80, 400, 100, 20,
                         hwnd, (HMENU) IDB_BUTTON_Po, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

            hwndEditRo = CreateWindow (TEXT ("button"), "radial basis function",
                         WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX,
                         80, 420, 150, 20,
                         hwnd, (HMENU) IDB_BUTTON_RBFo, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

            hwndEditSo = CreateWindow (TEXT ("button"), "sigmoid",
                         WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX,
                         80, 440, 70, 20,
                         hwnd, (HMENU) IDB_BUTTON_So, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

            //linear




            //polynomial


            hwndEditP1a = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | ES_NUMBER | WS_TABSTOP,
                         290, 400, 60, 20,
                         hwnd, (HMENU) ID_EDIT_P1a, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditP1b = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | ES_NUMBER | WS_TABSTOP,
                         350, 400, 60, 20,
                         hwnd, (HMENU) ID_EDIT_P1b, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;


            hwndEditP2a = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         430, 400, 60, 20,
                         hwnd, (HMENU) ID_EDIT_P2a, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditP2b = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         490, 400, 60, 20,
                         hwnd, (HMENU) ID_EDIT_P2b, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

            hwndEditP3a = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         570, 400, 60, 20,
                         hwnd, (HMENU) ID_EDIT_P3a, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditP3b = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         630, 400, 60, 20,
                         hwnd, (HMENU) ID_EDIT_P3b, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;



            //radial basis function

            hwndEditR1a = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         290, 420, 60, 20,
                         hwnd, (HMENU) ID_EDIT_RBF1a, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditR1b = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         350, 420, 60, 20,
                         hwnd, (HMENU) ID_EDIT_RBF1b, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;



            //sigmoid

            hwndEditS1a = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         290, 440, 60, 20,
                         hwnd, (HMENU) ID_EDIT_S1a, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditS1b = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         350, 440, 60, 20,
                         hwnd, (HMENU) ID_EDIT_S1b, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

            hwndEditS2a = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         430, 440, 60, 20,
                         hwnd, (HMENU) ID_EDIT_S2a, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditS2b = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         490, 440, 60, 20,
                         hwnd, (HMENU) ID_EDIT_S2b, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;





            hwndEditRuns = CreateWindow (TEXT ("edit"), NULL,
                         WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                         150, 480, 60, 20,
                         hwnd, (HMENU) ID_EDIT_RUNS, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;


            //Train
            hWndButtonTrain = CreateWindowEx(
                0,
                "BUTTON",
                "Train file...",
                WS_VISIBLE | WS_CHILD,
                220,
                10,
                140,
                20,
                hwnd,
                (HMENU) IDB_BUTTON_TRAIN,
                hInstance,
                NULL);



            //Test
            hWndButtonTest = CreateWindowEx(
                0,
                "BUTTON",
                "Test file...",
                WS_VISIBLE | WS_CHILD,
                220,
                30,
                140,
                20,
                hwnd,
                (HMENU) IDB_BUTTON_TEST,
                hInstance,
                NULL);


            //Model
            hWndButtonModel = CreateWindowEx(
                0,
                "BUTTON",
                "Model file...",
                WS_VISIBLE | WS_CHILD,
                220,
                120,
                140,
                20,
                hwnd,
                (HMENU) IDB_BUTTON_MODEL,
                hInstance,
                NULL);




            //Predictions
            hWndButtonPredictions = CreateWindowEx(
                0,
                "BUTTON",
                "Predictions file...",
                WS_VISIBLE | WS_CHILD,
                220,
                140,
                140,
                20,
                hwnd,
                (HMENU) IDB_BUTTON_PREDICTIONS,
                hInstance,
                NULL);


            //Optimize
            hWndButtonOptimize = CreateWindowEx(
                0,
                "BUTTON",
                "Optimize file...",
                WS_VISIBLE | WS_CHILD,
                220,
                340,
                140,
                20,
                hwnd,
                (HMENU) IDB_BUTTON_OPTIMIZEF,
                hInstance,
                NULL);






            //Learn
            hWndButtonLearn = CreateWindowEx(
                0,
                "BUTTON",
                "Learn",
                WS_VISIBLE | WS_CHILD,
                20,
                240,
                100,
                40,
                hwnd,
                (HMENU) IDB_BUTTON_LEARN,
                hInstance,
                NULL);

            //Classify
            hWndButtonClassify = CreateWindowEx(
                0,
                "BUTTON",
                "Predict",
                WS_VISIBLE | WS_CHILD,
                130,
                240,
                100,
                40,
                hwnd,
                (HMENU) IDB_BUTTON_CLASSIFY,
                hInstance,
                NULL);


            //Optimize
            hWndButtonOptimize = CreateWindowEx(
                0,
                "BUTTON",
                "Optimize",
                WS_VISIBLE | WS_CHILD,
                20,
                460,
                100,
                40,
                hwnd,
                (HMENU) IDB_BUTTON_OPTIMIZE,
                hInstance,
                NULL);


            hdc = GetDC (hwnd) ;
            GetTextMetrics (hdc, &tm) ;

            hwndEditTrainFilename = CreateWindowEx (WS_EX_CLIENTEDGE, TEXT ("static"), TrainFilename,
                         WS_CHILD | WS_VISIBLE | ES_READONLY,
                         370, 10, 400, 20,
                         hwnd, (HMENU) ID_EDIT_TrF, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditTestFilename = CreateWindowEx (WS_EX_CLIENTEDGE, TEXT ("static"), TestFilename,
                         WS_CHILD | WS_VISIBLE | ES_READONLY,
                         370, 30, 400, 20,
                         hwnd, (HMENU) ID_EDIT_TeF, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditModelFilename = CreateWindowEx (WS_EX_CLIENTEDGE, TEXT ("static"), ModelFilename,
                         WS_CHILD | WS_VISIBLE | ES_READONLY,
                         370, 120, 400, 20,
                         hwnd, (HMENU) ID_EDIT_MF, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditPredictionsFilename = CreateWindowEx (WS_EX_CLIENTEDGE, TEXT ("static"), PredictionsFilename,
                         WS_CHILD | WS_VISIBLE | ES_READONLY,
                         370, 140, 400, 20,
                         hwnd, (HMENU) ID_EDIT_PF, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;
            hwndEditOptimizeFilename = CreateWindowEx (WS_EX_CLIENTEDGE, TEXT ("static"), OptimizeFilename,
                         WS_CHILD | WS_VISIBLE | ES_READONLY,
                         370, 340, 400, 20,
                         hwnd, (HMENU) ID_EDIT_OF, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

            hwndEditCounter = CreateWindowEx (WS_EX_CLIENTEDGE, TEXT ("static"), (char *)perc,
                         WS_CHILD | WS_VISIBLE | ES_READONLY,
                         290, 480, 40, 20,
                         hwnd, (HMENU) ID_EDIT_OF, ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

            return 0 ;




     case WM_COMMAND:
            switch (LOWORD(wParam))
            {

            case IDB_BUTTON_TRAIN:
                GetTrainFilename("TXT files (*.txt)","*.txt");
                SendMessage(hwndEditTrainFilename, WM_SETTEXT, 0, (LPARAM)TrainFilename);
                return 0 ;

            case IDB_BUTTON_MODEL:
                GetModelFilename("txt");
                SendMessage(hwndEditModelFilename, WM_SETTEXT, 0, (LPARAM)ModelFilename);
                return 0 ;

            case IDB_BUTTON_TEST:
                GetTestFilename("TXT files (*.txt)","*.txt");
                SendMessage(hwndEditTestFilename, WM_SETTEXT, 0, (LPARAM)TestFilename);
                return 0 ;

            case IDB_BUTTON_PREDICTIONS:
                GetPredictionsFilename("txt");
                SendMessage(hwndEditPredictionsFilename, WM_SETTEXT, 0, (LPARAM)PredictionsFilename);
                return 0 ;

            case IDB_BUTTON_OPTIMIZEF:
                GetOptimizeFilename("txt");
                SendMessage(hwndEditOptimizeFilename, WM_SETTEXT, 0, (LPARAM)OptimizeFilename);
                return 0 ;




            case IDB_BUTTON_LEARN:
                 if ((train_stream = fopen (TrainFilename, "r")) == NULL)
                     MessageBox(NULL, TrainFilename, "Failed to open file", MB_OK | MB_ICONINFORMATION);
                 else {
                     fclose(train_stream);
                     SetCursor(LoadCursor(NULL,IDC_WAIT));
                     ShowCursor(TRUE);
                     learn_main();
                     ShowCursor(FALSE);
                     SetCursor(LoadCursor(NULL,IDC_ARROW));
                 }
                 break;

            case IDB_BUTTON_CLASSIFY:
                 if ((test_stream = fopen (TestFilename, "r")) == NULL)
                     MessageBox(NULL, TestFilename, "Failed to open file", MB_OK | MB_ICONINFORMATION);
                 else {
                     fclose(test_stream);
                     SetCursor(LoadCursor(NULL,IDC_WAIT));
                     ShowCursor(TRUE);
                     classify();
                     ShowCursor(FALSE);
                     SetCursor(LoadCursor(NULL,IDC_ARROW));
                 }
                 break;

            case IDB_BUTTON_OPTIMIZE:
                 if ((train_stream = fopen (TrainFilename, "r")) == NULL)
                     MessageBox(NULL, TrainFilename, "Failed to open file", MB_OK | MB_ICONINFORMATION);
                 else {
                     fclose(train_stream);
                     if ((test_stream = fopen (TestFilename, "r")) == NULL)
                         MessageBox(NULL, TestFilename, "Failed to open file", MB_OK | MB_ICONINFORMATION);
                     else {
                         fclose(test_stream);
                         if ((optimize_stream = fopen (OptimizeFilename, "w")) == NULL)
                             MessageBox(NULL, OptimizeFilename, "Failed to open file", MB_OK | MB_ICONINFORMATION);
                         else {
                             fclose(optimize_stream);                      
                             SetCursor(LoadCursor(NULL,IDC_WAIT));
                             ShowCursor(TRUE);
                             optimize();
                             ShowCursor(FALSE);
                             SetCursor(LoadCursor(NULL,IDC_ARROW));
                         }
                     }
                 }
                 break;

            //Menu

            case IDM_APP_EXIT:
                SendMessage (hwnd, WM_CLOSE, 0, 0) ;
                return 0 ;
            case IDM_APP_HELP:
                MessageBox (hwnd, TEXT ("See: http://www.cs.ucl.ac.uk/staff/M.Sewell/svmdark/"),
                                  szClassName, MB_ICONINFORMATION | MB_OK) ;
                return 0;
            case IDM_APP_ABOUT:
                MessageBox (hwnd, TEXT ("SVMdark\n")
                                  TEXT ("(c) Martin Sewell, 2005"),
                                  szClassName, MB_ICONINFORMATION | MB_OK) ;
                return 0;
            }








        case WM_PAINT :




            hdc = BeginPaint (hwnd, &ps);
            SetBkColor (hdc, GetSysColor (COLOR_BTNFACE)) ;
            SetTextColor (hdc, GetSysColor (COLOR_WINDOWTEXT)) ;

//Rectangles
MoveToEx (hdc, 10, 110, NULL);
LineTo (hdc, 780, 110);
LineTo (hdc, 780, 290);
LineTo (hdc, 10, 290);
LineTo (hdc, 10, 110);

MoveToEx (hdc, 10, 330, NULL);
LineTo (hdc, 780, 330);
LineTo (hdc, 780, 510);
LineTo (hdc, 10, 510);
LineTo (hdc, 10, 330);





            TextOut (hdc, 220, 50, "polynomial: (s a*b+c)^d", strlen("polynomial: (s a*b+c)^d"));
            TextOut (hdc, 220, 70, "radial basis function: exp(-gamma ||a-b||^2)", strlen("radial basis function: exp(-gamma ||a-b||^2)"));
            TextOut (hdc, 220, 90, "sigmoid: tanh(s a*b + c)", strlen("sigmoid: tanh(s a*b + c)"));


            TextOut (hdc, 20, 120, "C", 1);

            TextOut (hdc, 20, 140, "epsilon", 7);

            TextOut (hdc, 20, 160, "kernel", 6);

            TextOut (hdc, 240, 180, "d", 1);
            TextOut (hdc, 380, 180, "s", 1);
            TextOut (hdc, 480, 180, "c", 1);

            TextOut (hdc, 240, 200, "gamma", 5);

            TextOut (hdc, 240, 220, "s", 1);
            TextOut (hdc, 380, 220, "c", 1);


//Optimize
            TextOut (hdc, 20, 340, "C", 1);

            TextOut (hdc, 20, 360, "epsilon", 7);

            TextOut (hdc, 20, 380, "kernel", 6);

            TextOut (hdc, 240, 400, "d", 1);
            TextOut (hdc, 420, 400, "s", 1);
            TextOut (hdc, 560, 400, "c", 1);

            TextOut (hdc, 240, 420, "gamma", 5);

            TextOut (hdc, 240, 440, "s", 1);
            TextOut (hdc, 420, 440, "c", 1);


            TextOut (hdc, 220, 480, "runs", 4);




            EndPaint (hwnd, &ps) ;
            return 0 ;

        case WM_SYSCOLORCHANGE:
            InvalidateRect (hwnd, NULL, TRUE) ;
            break ;


        case WM_DESTROY:
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

}

